# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Connection do
  @moduledoc """
  Handle Tesla connections for GoogleApi.Chat.V1.
  """

  @type t :: Tesla.Env.client()

  use GoogleApi.Gax.Connection,
    scopes: [
      # Private Service: https://www.googleapis.com/auth/chat.bot
      "https://www.googleapis.com/auth/chat.bot",

      # Delete conversations and spaces & remove access to associated files in Google Chat
      "https://www.googleapis.com/auth/chat.delete",

      # Import spaces, messages, and memberships into Google Chat.
      "https://www.googleapis.com/auth/chat.import",

      # View, add, and remove members from conversations in Google Chat
      "https://www.googleapis.com/auth/chat.memberships",

      # Add and remove itself from conversations in Google Chat
      "https://www.googleapis.com/auth/chat.memberships.app",

      # View members in Google Chat conversations.
      "https://www.googleapis.com/auth/chat.memberships.readonly",

      # View, compose, send, update, and delete messages, and add, view, and delete reactions to messages.
      "https://www.googleapis.com/auth/chat.messages",

      # Compose and send messages in Google Chat
      "https://www.googleapis.com/auth/chat.messages.create",

      # View, add, and delete reactions to messages in Google Chat
      "https://www.googleapis.com/auth/chat.messages.reactions",

      # Add reactions to messages in Google Chat
      "https://www.googleapis.com/auth/chat.messages.reactions.create",

      # View reactions to messages in Google Chat
      "https://www.googleapis.com/auth/chat.messages.reactions.readonly",

      # View messages and reactions in Google Chat
      "https://www.googleapis.com/auth/chat.messages.readonly",

      # Create conversations and spaces and see or edit metadata (including history settings and access settings) in Google Chat
      "https://www.googleapis.com/auth/chat.spaces",

      # Create new conversations in Google Chat
      "https://www.googleapis.com/auth/chat.spaces.create",

      # View chat and spaces in Google Chat
      "https://www.googleapis.com/auth/chat.spaces.readonly"
    ],
    otp_app: :google_api_chat,
    base_url: "https://chat.googleapis.com/"
end
