# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.Card do
  @moduledoc """
  A card is a UI element that can contain UI widgets such as text and images.

  ## Attributes

  *   `cardActions` (*type:* `list(GoogleApi.Chat.V1.Model.CardAction.t)`, *default:* `nil`) - The actions of this card.
  *   `header` (*type:* `GoogleApi.Chat.V1.Model.CardHeader.t`, *default:* `nil`) - The header of the card. A header usually contains a title and an image.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Name of the card.
  *   `sections` (*type:* `list(GoogleApi.Chat.V1.Model.Section.t)`, *default:* `nil`) - Sections are separated by a line divider.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cardActions => list(GoogleApi.Chat.V1.Model.CardAction.t()) | nil,
          :header => GoogleApi.Chat.V1.Model.CardHeader.t() | nil,
          :name => String.t() | nil,
          :sections => list(GoogleApi.Chat.V1.Model.Section.t()) | nil
        }

  field(:cardActions, as: GoogleApi.Chat.V1.Model.CardAction, type: :list)
  field(:header, as: GoogleApi.Chat.V1.Model.CardHeader)
  field(:name)
  field(:sections, as: GoogleApi.Chat.V1.Model.Section, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.Card do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.Card.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.Card do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
