# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.CardHeader do
  @moduledoc """


  ## Attributes

  *   `imageStyle` (*type:* `String.t`, *default:* `nil`) - The image's type (for example, square border or circular border).
  *   `imageUrl` (*type:* `String.t`, *default:* `nil`) - The URL of the image in the card header.
  *   `subtitle` (*type:* `String.t`, *default:* `nil`) - The subtitle of the card header.
  *   `title` (*type:* `String.t`, *default:* `nil`) - The title must be specified. The header has a fixed height: if both a title and subtitle is specified, each takes up one line. If only the title is specified, it takes up both lines.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :imageStyle => String.t() | nil,
          :imageUrl => String.t() | nil,
          :subtitle => String.t() | nil,
          :title => String.t() | nil
        }

  field(:imageStyle)
  field(:imageUrl)
  field(:subtitle)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.CardHeader do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.CardHeader.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.CardHeader do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
