# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.CardWithId do
  @moduledoc """
  A [card](https://developers.google.com/chat/api/reference/rest/v1/cards) in a Google Chat message. Only Chat apps can create cards. If your Chat app [authenticates as a user](https://developers.google.com/chat/api/guides/auth/users), the message can't contain cards. [Card builder](https://addons.gsuite.google.com/uikit/builder)

  ## Attributes

  *   `card` (*type:* `GoogleApi.Chat.V1.Model.GoogleAppsCardV1Card.t`, *default:* `nil`) - A card. Maximum size is 32 KB.
  *   `cardId` (*type:* `String.t`, *default:* `nil`) - Required if the message contains multiple cards. A unique identifier for a card in a message.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :card => GoogleApi.Chat.V1.Model.GoogleAppsCardV1Card.t() | nil,
          :cardId => String.t() | nil
        }

  field(:card, as: GoogleApi.Chat.V1.Model.GoogleAppsCardV1Card)
  field(:cardId)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.CardWithId do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.CardWithId.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.CardWithId do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
