# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.ChatAppLogEntry do
  @moduledoc """
  JSON payload of error messages. If the Cloud Logging API is enabled, these error messages are logged to [Google Cloud Logging](https://cloud.google.com/logging/docs).

  ## Attributes

  *   `deployment` (*type:* `String.t`, *default:* `nil`) - The deployment that caused the error. For Chat apps built in Apps Script, this is the deployment ID defined by Apps Script.
  *   `deploymentFunction` (*type:* `String.t`, *default:* `nil`) - The unencrypted `callback_method` name that was running when the error was encountered.
  *   `error` (*type:* `GoogleApi.Chat.V1.Model.Status.t`, *default:* `nil`) - The error code and message.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :deployment => String.t() | nil,
          :deploymentFunction => String.t() | nil,
          :error => GoogleApi.Chat.V1.Model.Status.t() | nil
        }

  field(:deployment)
  field(:deploymentFunction)
  field(:error, as: GoogleApi.Chat.V1.Model.Status)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.ChatAppLogEntry do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.ChatAppLogEntry.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.ChatAppLogEntry do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
