# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.ChatClientDataSourceMarkup do
  @moduledoc """
  For a `SelectionInput` widget that uses a multiselect menu, a data source from Google Chat. The data source populates selection items for the multiselect menu. For example, a user can select Google Chat spaces that they're a member of. [Google Chat apps](https://developers.google.com/workspace/chat):

  ## Attributes

  *   `spaceDataSource` (*type:* `GoogleApi.Chat.V1.Model.SpaceDataSource.t`, *default:* `nil`) - Google Chat spaces that the user is a member of.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :spaceDataSource => GoogleApi.Chat.V1.Model.SpaceDataSource.t() | nil
        }

  field(:spaceDataSource, as: GoogleApi.Chat.V1.Model.SpaceDataSource)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.ChatClientDataSourceMarkup do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.ChatClientDataSourceMarkup.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.ChatClientDataSourceMarkup do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
