# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.DialogAction do
  @moduledoc """
  Contains a [dialog](https://developers.google.com/chat/how-tos/dialogs) and request status code.

  ## Attributes

  *   `actionStatus` (*type:* `GoogleApi.Chat.V1.Model.ActionStatus.t`, *default:* `nil`) - Input only. Status for a request to either invoke or submit a [dialog](https://developers.google.com/chat/how-tos/dialogs). Displays a status and message to users, if necessary. For example, in case of an error or success.
  *   `dialog` (*type:* `GoogleApi.Chat.V1.Model.Dialog.t`, *default:* `nil`) - Input only. [Dialog](https://developers.google.com/chat/how-tos/dialogs) for the request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :actionStatus => GoogleApi.Chat.V1.Model.ActionStatus.t() | nil,
          :dialog => GoogleApi.Chat.V1.Model.Dialog.t() | nil
        }

  field(:actionStatus, as: GoogleApi.Chat.V1.Model.ActionStatus)
  field(:dialog, as: GoogleApi.Chat.V1.Model.Dialog)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.DialogAction do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.DialogAction.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.DialogAction do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
