# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.DriveLinkData do
  @moduledoc """
  Data for Google Drive links.

  ## Attributes

  *   `driveDataRef` (*type:* `GoogleApi.Chat.V1.Model.DriveDataRef.t`, *default:* `nil`) - A [DriveDataRef](https://developers.google.com/chat/api/reference/rest/v1/spaces.messages.attachments#drivedataref) which references a Google Drive file.
  *   `mimeType` (*type:* `String.t`, *default:* `nil`) - The mime type of the linked Google Drive resource.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :driveDataRef => GoogleApi.Chat.V1.Model.DriveDataRef.t() | nil,
          :mimeType => String.t() | nil
        }

  field(:driveDataRef, as: GoogleApi.Chat.V1.Model.DriveDataRef)
  field(:mimeType)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.DriveLinkData do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.DriveLinkData.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.DriveLinkData do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
