# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.GoogleAppsCardV1ButtonList do
  @moduledoc """
  A list of buttons layed out horizontally. For an example in Google Chat apps, see [Button list](https://developers.google.com/chat/ui/widgets/button-list). [Google Workspace Add-ons and Chat apps](https://developers.google.com/workspace/extend):

  ## Attributes

  *   `buttons` (*type:* `list(GoogleApi.Chat.V1.Model.GoogleAppsCardV1Button.t)`, *default:* `nil`) - An array of buttons.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :buttons => list(GoogleApi.Chat.V1.Model.GoogleAppsCardV1Button.t()) | nil
        }

  field(:buttons, as: GoogleApi.Chat.V1.Model.GoogleAppsCardV1Button, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.GoogleAppsCardV1ButtonList do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.GoogleAppsCardV1ButtonList.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.GoogleAppsCardV1ButtonList do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
