# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.GoogleAppsCardV1CardHeader do
  @moduledoc """
  Represents a card header. For an example in Google Chat apps, see [Card header](https://developers.google.com/chat/ui/widgets/card-header). [Google Workspace Add-ons and Chat apps](https://developers.google.com/workspace/extend):

  ## Attributes

  *   `imageAltText` (*type:* `String.t`, *default:* `nil`) - The alternative text of this image that's used for accessibility.
  *   `imageType` (*type:* `String.t`, *default:* `nil`) - The shape used to crop the image. [Google Workspace Add-ons and Chat apps](https://developers.google.com/workspace/extend):
  *   `imageUrl` (*type:* `String.t`, *default:* `nil`) - The HTTPS URL of the image in the card header.
  *   `subtitle` (*type:* `String.t`, *default:* `nil`) - The subtitle of the card header. If specified, appears on its own line below the `title`.
  *   `title` (*type:* `String.t`, *default:* `nil`) - Required. The title of the card header. The header has a fixed height: if both a title and subtitle are specified, each takes up one line. If only the title is specified, it takes up both lines.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :imageAltText => String.t() | nil,
          :imageType => String.t() | nil,
          :imageUrl => String.t() | nil,
          :subtitle => String.t() | nil,
          :title => String.t() | nil
        }

  field(:imageAltText)
  field(:imageType)
  field(:imageUrl)
  field(:subtitle)
  field(:title)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.GoogleAppsCardV1CardHeader do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.GoogleAppsCardV1CardHeader.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.GoogleAppsCardV1CardHeader do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
