# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.ImageButton do
  @moduledoc """
  An image button with an `onclick` action.

  ## Attributes

  *   `icon` (*type:* `String.t`, *default:* `nil`) - The icon specified by an `enum` that indices to an icon provided by Chat API.
  *   `iconUrl` (*type:* `String.t`, *default:* `nil`) - The icon specified by a URL.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of this `image_button` that's used for accessibility. Default value is provided if this name isn't specified.
  *   `onClick` (*type:* `GoogleApi.Chat.V1.Model.OnClick.t`, *default:* `nil`) - The `onclick` action.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :icon => String.t() | nil,
          :iconUrl => String.t() | nil,
          :name => String.t() | nil,
          :onClick => GoogleApi.Chat.V1.Model.OnClick.t() | nil
        }

  field(:icon)
  field(:iconUrl)
  field(:name)
  field(:onClick, as: GoogleApi.Chat.V1.Model.OnClick)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.ImageButton do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.ImageButton.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.ImageButton do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
