# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.QuotedMessageMetadata do
  @moduledoc """
  Information about a quoted message.

  ## Attributes

  *   `lastUpdateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the quoted message was created or when the quoted message was last updated.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Output only. Resource name of the quoted message. Format: `spaces/{space}/messages/{message}`
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :lastUpdateTime => DateTime.t() | nil,
          :name => String.t() | nil
        }

  field(:lastUpdateTime, as: DateTime)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.QuotedMessageMetadata do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.QuotedMessageMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.QuotedMessageMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
