# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.Reaction do
  @moduledoc """
  A reaction to a message.

  ## Attributes

  *   `emoji` (*type:* `GoogleApi.Chat.V1.Model.Emoji.t`, *default:* `nil`) - The emoji used in the reaction.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The resource name of the reaction. Format: `spaces/{space}/messages/{message}/reactions/{reaction}`
  *   `user` (*type:* `GoogleApi.Chat.V1.Model.User.t`, *default:* `nil`) - Output only. The user who created the reaction.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :emoji => GoogleApi.Chat.V1.Model.Emoji.t() | nil,
          :name => String.t() | nil,
          :user => GoogleApi.Chat.V1.Model.User.t() | nil
        }

  field(:emoji, as: GoogleApi.Chat.V1.Model.Emoji)
  field(:name)
  field(:user, as: GoogleApi.Chat.V1.Model.User)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.Reaction do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.Reaction.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.Reaction do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
