# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.RichLinkMetadata do
  @moduledoc """
  A rich link to a resource.

  ## Attributes

  *   `driveLinkData` (*type:* `GoogleApi.Chat.V1.Model.DriveLinkData.t`, *default:* `nil`) - Data for a drive link.
  *   `richLinkType` (*type:* `String.t`, *default:* `nil`) - The rich link type.
  *   `uri` (*type:* `String.t`, *default:* `nil`) - The URI of this link.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :driveLinkData => GoogleApi.Chat.V1.Model.DriveLinkData.t() | nil,
          :richLinkType => String.t() | nil,
          :uri => String.t() | nil
        }

  field(:driveLinkData, as: GoogleApi.Chat.V1.Model.DriveLinkData)
  field(:richLinkType)
  field(:uri)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.RichLinkMetadata do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.RichLinkMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.RichLinkMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
