# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.TimeZone do
  @moduledoc """
  The timezone ID and offset from Coordinated Universal Time (UTC). Only supported for the event types [`CARD_CLICKED`](https://developers.google.com/chat/api/reference/rest/v1/EventType#ENUM_VALUES.CARD_CLICKED) and [`SUBMIT_DIALOG`](https://developers.google.com/chat/api/reference/rest/v1/DialogEventType#ENUM_VALUES.SUBMIT_DIALOG).

  ## Attributes

  *   `id` (*type:* `String.t`, *default:* `nil`) - The [IANA TZ](https://www.iana.org/time-zones) time zone database code, such as "America/Toronto".
  *   `offset` (*type:* `integer()`, *default:* `nil`) - The user timezone offset, in milliseconds, from Coordinated Universal Time (UTC).
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :id => String.t() | nil,
          :offset => integer() | nil
        }

  field(:id)
  field(:offset)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.TimeZone do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.TimeZone.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.TimeZone do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
