# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Chat.V1.Model.WidgetMarkup do
  @moduledoc """
  A widget is a UI element that presents text and images.

  ## Attributes

  *   `buttons` (*type:* `list(GoogleApi.Chat.V1.Model.Button.t)`, *default:* `nil`) - A list of buttons. Buttons is also `oneof data` and only one of these fields should be set.
  *   `image` (*type:* `GoogleApi.Chat.V1.Model.Image.t`, *default:* `nil`) - Display an image in this widget.
  *   `keyValue` (*type:* `GoogleApi.Chat.V1.Model.KeyValue.t`, *default:* `nil`) - Display a key value item in this widget.
  *   `textParagraph` (*type:* `GoogleApi.Chat.V1.Model.TextParagraph.t`, *default:* `nil`) - Display a text paragraph in this widget.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :buttons => list(GoogleApi.Chat.V1.Model.Button.t()) | nil,
          :image => GoogleApi.Chat.V1.Model.Image.t() | nil,
          :keyValue => GoogleApi.Chat.V1.Model.KeyValue.t() | nil,
          :textParagraph => GoogleApi.Chat.V1.Model.TextParagraph.t() | nil
        }

  field(:buttons, as: GoogleApi.Chat.V1.Model.Button, type: :list)
  field(:image, as: GoogleApi.Chat.V1.Model.Image)
  field(:keyValue, as: GoogleApi.Chat.V1.Model.KeyValue)
  field(:textParagraph, as: GoogleApi.Chat.V1.Model.TextParagraph)
end

defimpl Poison.Decoder, for: GoogleApi.Chat.V1.Model.WidgetMarkup do
  def decode(value, options) do
    GoogleApi.Chat.V1.Model.WidgetMarkup.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Chat.V1.Model.WidgetMarkup do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
